<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source to the Rust file `/home/keir/.cargo/registry/src/github.com-1ecc6299db9ec823/rand-0.7.3/src/distributions/mod.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>mod.rs.html -- source</title><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../dark.css"><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script src="../../../storage.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="shortcut icon" href="https://www.rust-lang.org/favicon.ico"><style type="text/css">#crate-search{background-image:url("../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../../rand/index.html'><div class='logo-container'><img src='https://www.rust-lang.org/logos/rust-logo-128x128-blk.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!"><img src="../../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices"></div></div><script src="../../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><a id="settings-menu" href="../../../settings.html"><img src="../../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="comment">// Copyright 2018 Developers of the Rand project.</span>
<span class="comment">// Copyright 2013-2017 The Rust Project Developers.</span>
<span class="comment">//</span>
<span class="comment">// Licensed under the Apache License, Version 2.0 &lt;LICENSE-APACHE or</span>
<span class="comment">// https://www.apache.org/licenses/LICENSE-2.0&gt; or the MIT license</span>
<span class="comment">// &lt;LICENSE-MIT or https://opensource.org/licenses/MIT&gt;, at your</span>
<span class="comment">// option. This file may not be copied, modified, or distributed</span>
<span class="comment">// except according to those terms.</span>

<span class="doccomment">//! Generating random samples from probability distributions</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This module is the home of the [`Distribution`] trait and several of its</span>
<span class="doccomment">//! implementations. It is the workhorse behind some of the convenient</span>
<span class="doccomment">//! functionality of the [`Rng`] trait, e.g. [`Rng::gen`], [`Rng::gen_range`] and</span>
<span class="doccomment">//! of course [`Rng::sample`].</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Abstractly, a [probability distribution] describes the probability of</span>
<span class="doccomment">//! occurance of each value in its sample space.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! More concretely, an implementation of `Distribution&lt;T&gt;` for type `X` is an</span>
<span class="doccomment">//! algorithm for choosing values from the sample space (a subset of `T`)</span>
<span class="doccomment">//! according to the distribution `X` represents, using an external source of</span>
<span class="doccomment">//! randomness (an RNG supplied to the `sample` function).</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! A type `X` may implement `Distribution&lt;T&gt;` for multiple types `T`.</span>
<span class="doccomment">//! Any type implementing [`Distribution`] is stateless (i.e. immutable),</span>
<span class="doccomment">//! but it may have internal parameters set at construction time (for example,</span>
<span class="doccomment">//! [`Uniform`] allows specification of its sample space as a range within `T`).</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # The `Standard` distribution</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The [`Standard`] distribution is important to mention. This is the</span>
<span class="doccomment">//! distribution used by [`Rng::gen`] and represents the &quot;default&quot; way to</span>
<span class="doccomment">//! produce a random value for many different types, including most primitive</span>
<span class="doccomment">//! types, tuples, arrays, and a few derived types. See the documentation of</span>
<span class="doccomment">//! [`Standard`] for more details.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Implementing `Distribution&lt;T&gt;` for [`Standard`] for user types `T` makes it</span>
<span class="doccomment">//! possible to generate type `T` with [`Rng::gen`], and by extension also</span>
<span class="doccomment">//! with the [`random`] function.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Random characters</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [`Alphanumeric`] is a simple distribution to sample random letters and</span>
<span class="doccomment">//! numbers of the `char` type; in contrast [`Standard`] may sample any valid</span>
<span class="doccomment">//! `char`.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Uniform numeric ranges</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The [`Uniform`] distribution is more flexible than [`Standard`], but also</span>
<span class="doccomment">//! more specialised: it supports fewer target types, but allows the sample</span>
<span class="doccomment">//! space to be specified as an arbitrary range within its target type `T`.</span>
<span class="doccomment">//! Both [`Standard`] and [`Uniform`] are in some sense uniform distributions.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Values may be sampled from this distribution using [`Rng::gen_range`] or</span>
<span class="doccomment">//! by creating a distribution object with [`Uniform::new`],</span>
<span class="doccomment">//! [`Uniform::new_inclusive`] or `From&lt;Range&gt;`. When the range limits are not</span>
<span class="doccomment">//! known at compile time it is typically faster to reuse an existing</span>
<span class="doccomment">//! distribution object than to call [`Rng::gen_range`].</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! User types `T` may also implement `Distribution&lt;T&gt;` for [`Uniform`],</span>
<span class="doccomment">//! although this is less straightforward than for [`Standard`] (see the</span>
<span class="doccomment">//! documentation in the [`uniform`] module. Doing so enables generation of</span>
<span class="doccomment">//! values of type `T` with  [`Rng::gen_range`].</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Open and half-open ranges</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! There are surprisingly many ways to uniformly generate random floats. A</span>
<span class="doccomment">//! range between 0 and 1 is standard, but the exact bounds (open vs closed)</span>
<span class="doccomment">//! and accuracy differ. In addition to the [`Standard`] distribution Rand offers</span>
<span class="doccomment">//! [`Open01`] and [`OpenClosed01`]. See &quot;Floating point implementation&quot; section of</span>
<span class="doccomment">//! [`Standard`] documentation for more details.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Non-uniform sampling</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Sampling a simple true/false outcome with a given probability has a name:</span>
<span class="doccomment">//! the [`Bernoulli`] distribution (this is used by [`Rng::gen_bool`]).</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! For weighted sampling from a sequence of discrete values, use the</span>
<span class="doccomment">//! [`weighted`] module.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This crate no longer includes other non-uniform distributions; instead</span>
<span class="doccomment">//! it is recommended that you use either [`rand_distr`] or [`statrs`].</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [probability distribution]: https://en.wikipedia.org/wiki/Probability_distribution</span>
<span class="doccomment">//! [`rand_distr`]: https://crates.io/crates/rand_distr</span>
<span class="doccomment">//! [`statrs`]: https://crates.io/crates/statrs</span>

<span class="doccomment">//! [`random`]: crate::random</span>
<span class="doccomment">//! [`rand_distr`]: https://crates.io/crates/rand_distr</span>
<span class="doccomment">//! [`statrs`]: https://crates.io/crates/statrs</span>

<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">Rng</span>;
<span class="kw">use</span> <span class="ident">core</span>::<span class="ident">iter</span>;

<span class="kw">pub</span> <span class="kw">use</span> <span class="self">self</span>::<span class="ident">bernoulli</span>::{<span class="ident">Bernoulli</span>, <span class="ident">BernoulliError</span>};
<span class="kw">pub</span> <span class="kw">use</span> <span class="self">self</span>::<span class="ident">float</span>::{<span class="ident">Open01</span>, <span class="ident">OpenClosed01</span>};
<span class="kw">pub</span> <span class="kw">use</span> <span class="self">self</span>::<span class="ident">other</span>::<span class="ident">Alphanumeric</span>;
<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">inline</span>)]</span> <span class="kw">pub</span> <span class="kw">use</span> <span class="self">self</span>::<span class="ident">uniform</span>::<span class="ident">Uniform</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="self">self</span>::<span class="ident">weighted</span>::{<span class="ident">WeightedError</span>, <span class="ident">WeightedIndex</span>};

<span class="comment">// The following are all deprecated after being moved to rand_distr</span>
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="self">self</span>::<span class="ident">binomial</span>::<span class="ident">Binomial</span>;
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="self">self</span>::<span class="ident">cauchy</span>::<span class="ident">Cauchy</span>;
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="self">self</span>::<span class="ident">dirichlet</span>::<span class="ident">Dirichlet</span>;
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="self">self</span>::<span class="ident">exponential</span>::{<span class="ident">Exp</span>, <span class="ident">Exp1</span>};
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="self">self</span>::<span class="ident">gamma</span>::{<span class="ident">Beta</span>, <span class="ident">ChiSquared</span>, <span class="ident">FisherF</span>, <span class="ident">Gamma</span>, <span class="ident">StudentT</span>};
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="self">self</span>::<span class="ident">normal</span>::{<span class="ident">LogNormal</span>, <span class="ident">Normal</span>, <span class="ident">StandardNormal</span>};
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="self">self</span>::<span class="ident">pareto</span>::<span class="ident">Pareto</span>;
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="self">self</span>::<span class="ident">poisson</span>::<span class="ident">Poisson</span>;
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="self">self</span>::<span class="ident">triangular</span>::<span class="ident">Triangular</span>;
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="self">self</span>::<span class="ident">unit_circle</span>::<span class="ident">UnitCircle</span>;
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="self">self</span>::<span class="ident">unit_sphere</span>::<span class="ident">UnitSphereSurface</span>;
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="self">self</span>::<span class="ident">weibull</span>::<span class="ident">Weibull</span>;

<span class="kw">mod</span> <span class="ident">bernoulli</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span> <span class="kw">mod</span> <span class="ident">binomial</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span> <span class="kw">mod</span> <span class="ident">cauchy</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span> <span class="kw">mod</span> <span class="ident">dirichlet</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span> <span class="kw">mod</span> <span class="ident">exponential</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span> <span class="kw">mod</span> <span class="ident">gamma</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span> <span class="kw">mod</span> <span class="ident">normal</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span> <span class="kw">mod</span> <span class="ident">pareto</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span> <span class="kw">mod</span> <span class="ident">poisson</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span> <span class="kw">mod</span> <span class="ident">triangular</span>;
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">uniform</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span> <span class="kw">mod</span> <span class="ident">unit_circle</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span> <span class="kw">mod</span> <span class="ident">unit_sphere</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span> <span class="kw">mod</span> <span class="ident">weibull</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)]</span> <span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">weighted</span>;

<span class="kw">mod</span> <span class="ident">float</span>;
<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">hidden_export</span> {
    <span class="kw">pub</span> <span class="kw">use</span> <span class="kw">super</span>::<span class="ident">float</span>::<span class="ident">IntoFloat</span>; <span class="comment">// used by rand_distr</span>
}
<span class="kw">mod</span> <span class="ident">integer</span>;
<span class="kw">mod</span> <span class="ident">other</span>;
<span class="kw">mod</span> <span class="ident">utils</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span> <span class="kw">mod</span> <span class="ident">ziggurat_tables</span>;

<span class="doccomment">/// Types (distributions) that can be used to create a random instance of `T`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// It is possible to sample from a distribution through both the</span>
<span class="doccomment">/// `Distribution` and [`Rng`] traits, via `distr.sample(&amp;mut rng)` and</span>
<span class="doccomment">/// `rng.sample(distr)`. They also both offer the [`sample_iter`] method, which</span>
<span class="doccomment">/// produces an iterator that samples from the distribution.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// All implementations are expected to be immutable; this has the significant</span>
<span class="doccomment">/// advantage of not needing to consider thread safety, and for most</span>
<span class="doccomment">/// distributions efficient state-less sampling algorithms are available.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Implementations are typically expected to be portable with reproducible</span>
<span class="doccomment">/// results when used with a PRNG with fixed seed; see the</span>
<span class="doccomment">/// [portability chapter](https://rust-random.github.io/book/portability.html)</span>
<span class="doccomment">/// of The Rust Rand Book. In some cases this does not apply, e.g. the `usize`</span>
<span class="doccomment">/// type requires different sampling on 32-bit and 64-bit machines.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [`sample_iter`]: Distribution::method.sample_iter</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">Distribution</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Generate a random value of `T`, using `rng` as the source of randomness.</span>
    <span class="kw">fn</span> <span class="ident">sample</span><span class="op">&lt;</span><span class="ident">R</span>: <span class="ident">Rng</span> <span class="op">+</span> <span class="question-mark">?</span><span class="ident">Sized</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">rng</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">R</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">T</span>;

    <span class="doccomment">/// Create an iterator that generates random values of `T`, using `rng` as</span>
    <span class="doccomment">/// the source of randomness.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Note that this function takes `self` by value. This works since</span>
    <span class="doccomment">/// `Distribution&lt;T&gt;` is impl&#39;d for `&amp;D` where `D: Distribution&lt;T&gt;`,</span>
    <span class="doccomment">/// however borrowing is not automatic hence `distr.sample_iter(...)` may</span>
    <span class="doccomment">/// need to be replaced with `(&amp;distr).sample_iter(...)` to borrow or</span>
    <span class="doccomment">/// `(&amp;*distr).sample_iter(...)` to reborrow an existing reference.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Example</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// use rand::thread_rng;</span>
    <span class="doccomment">/// use rand::distributions::{Distribution, Alphanumeric, Uniform, Standard};</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// let rng = thread_rng();</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// // Vec of 16 x f32:</span>
    <span class="doccomment">/// let v: Vec&lt;f32&gt; = Standard.sample_iter(rng).take(16).collect();</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// // String:</span>
    <span class="doccomment">/// let s: String = Alphanumeric.sample_iter(rng).take(7).collect();</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// // Dice-rolling:</span>
    <span class="doccomment">/// let die_range = Uniform::new_inclusive(1, 6);</span>
    <span class="doccomment">/// let mut roll_die = die_range.sample_iter(rng);</span>
    <span class="doccomment">/// while roll_die.next().unwrap() != 6 {</span>
    <span class="doccomment">///     println!(&quot;Not a 6; rolling again!&quot;);</span>
    <span class="doccomment">/// }</span>
    <span class="doccomment">/// ```</span>
    <span class="kw">fn</span> <span class="ident">sample_iter</span><span class="op">&lt;</span><span class="ident">R</span><span class="op">&gt;</span>(<span class="self">self</span>, <span class="ident">rng</span>: <span class="ident">R</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">DistIter</span><span class="op">&lt;</span><span class="self">Self</span>, <span class="ident">R</span>, <span class="ident">T</span><span class="op">&gt;</span>
    <span class="kw">where</span>
        <span class="ident">R</span>: <span class="ident">Rng</span>,
        <span class="self">Self</span>: <span class="ident">Sized</span>,
    {
        <span class="ident">DistIter</span> {
            <span class="ident">distr</span>: <span class="self">self</span>,
            <span class="ident">rng</span>,
            <span class="ident">phantom</span>: ::<span class="ident">core</span>::<span class="ident">marker</span>::<span class="ident">PhantomData</span>,
        }
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">T</span>, <span class="ident">D</span>: <span class="ident">Distribution</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="ident">Distribution</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">D</span> {
    <span class="kw">fn</span> <span class="ident">sample</span><span class="op">&lt;</span><span class="ident">R</span>: <span class="ident">Rng</span> <span class="op">+</span> <span class="question-mark">?</span><span class="ident">Sized</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">rng</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">R</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">T</span> {
        (<span class="kw-2">*</span><span class="self">self</span>).<span class="ident">sample</span>(<span class="ident">rng</span>)
    }
}


<span class="doccomment">/// An iterator that generates random values of `T` with distribution `D`,</span>
<span class="doccomment">/// using `R` as the source of randomness.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This `struct` is created by the [`sample_iter`] method on [`Distribution`].</span>
<span class="doccomment">/// See its documentation for more.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [`sample_iter`]: Distribution::sample_iter</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DistIter</span><span class="op">&lt;</span><span class="ident">D</span>, <span class="ident">R</span>, <span class="ident">T</span><span class="op">&gt;</span> {
    <span class="ident">distr</span>: <span class="ident">D</span>,
    <span class="ident">rng</span>: <span class="ident">R</span>,
    <span class="ident">phantom</span>: ::<span class="ident">core</span>::<span class="ident">marker</span>::<span class="ident">PhantomData</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">D</span>, <span class="ident">R</span>, <span class="ident">T</span><span class="op">&gt;</span> <span class="ident">Iterator</span> <span class="kw">for</span> <span class="ident">DistIter</span><span class="op">&lt;</span><span class="ident">D</span>, <span class="ident">R</span>, <span class="ident">T</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">D</span>: <span class="ident">Distribution</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>,
    <span class="ident">R</span>: <span class="ident">Rng</span>,
{
    <span class="kw">type</span> <span class="ident">Item</span> <span class="op">=</span> <span class="ident">T</span>;

    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
    <span class="kw">fn</span> <span class="ident">next</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
        <span class="comment">// Here, self.rng may be a reference, but we must take &amp;mut anyway.</span>
        <span class="comment">// Even if sample could take an R: Rng by value, we would need to do this</span>
        <span class="comment">// since Rng is not copyable and we cannot enforce that this is &quot;reborrowable&quot;.</span>
        <span class="prelude-val">Some</span>(<span class="self">self</span>.<span class="ident">distr</span>.<span class="ident">sample</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>.<span class="ident">rng</span>))
    }

    <span class="kw">fn</span> <span class="ident">size_hint</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> (<span class="ident">usize</span>, <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>) {
        (<span class="ident">usize</span>::<span class="ident">max_value</span>(), <span class="prelude-val">None</span>)
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">D</span>, <span class="ident">R</span>, <span class="ident">T</span><span class="op">&gt;</span> <span class="ident">iter</span>::<span class="ident">FusedIterator</span> <span class="kw">for</span> <span class="ident">DistIter</span><span class="op">&lt;</span><span class="ident">D</span>, <span class="ident">R</span>, <span class="ident">T</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">D</span>: <span class="ident">Distribution</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>,
    <span class="ident">R</span>: <span class="ident">Rng</span>,
{
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">features</span> <span class="op">=</span> <span class="string">&quot;nightly&quot;</span>)]</span>
<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">D</span>, <span class="ident">R</span>, <span class="ident">T</span><span class="op">&gt;</span> <span class="ident">iter</span>::<span class="ident">TrustedLen</span> <span class="kw">for</span> <span class="ident">DistIter</span><span class="op">&lt;</span><span class="ident">D</span>, <span class="ident">R</span>, <span class="ident">T</span><span class="op">&gt;</span>
<span class="kw">where</span>
    <span class="ident">D</span>: <span class="ident">Distribution</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>,
    <span class="ident">R</span>: <span class="ident">Rng</span>,
{
}


<span class="doccomment">/// A generic random value distribution, implemented for many primitive types.</span>
<span class="doccomment">/// Usually generates values with a numerically uniform distribution, and with a</span>
<span class="doccomment">/// range appropriate to the type.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ## Provided implementations</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Assuming the provided `Rng` is well-behaved, these implementations</span>
<span class="doccomment">/// generate values with the following ranges and distributions:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// * Integers (`i32`, `u32`, `isize`, `usize`, etc.): Uniformly distributed</span>
<span class="doccomment">///   over all values of the type.</span>
<span class="doccomment">/// * `char`: Uniformly distributed over all Unicode scalar values, i.e. all</span>
<span class="doccomment">///   code points in the range `0...0x10_FFFF`, except for the range</span>
<span class="doccomment">///   `0xD800...0xDFFF` (the surrogate code points). This includes</span>
<span class="doccomment">///   unassigned/reserved code points.</span>
<span class="doccomment">/// * `bool`: Generates `false` or `true`, each with probability 0.5.</span>
<span class="doccomment">/// * Floating point types (`f32` and `f64`): Uniformly distributed in the</span>
<span class="doccomment">///   half-open range `[0, 1)`. See notes below.</span>
<span class="doccomment">/// * Wrapping integers (`Wrapping&lt;T&gt;`), besides the type identical to their</span>
<span class="doccomment">///   normal integer variants.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The `Standard` distribution also supports generation of the following</span>
<span class="doccomment">/// compound types where all component types are supported:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// *   Tuples (up to 12 elements): each element is generated sequentially.</span>
<span class="doccomment">/// *   Arrays (up to 32 elements): each element is generated sequentially;</span>
<span class="doccomment">///     see also [`Rng::fill`] which supports arbitrary array length for integer</span>
<span class="doccomment">///     types and tends to be faster for `u32` and smaller types.</span>
<span class="doccomment">/// *   `Option&lt;T&gt;` first generates a `bool`, and if true generates and returns</span>
<span class="doccomment">///     `Some(value)` where `value: T`, otherwise returning `None`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ## Custom implementations</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The [`Standard`] distribution may be implemented for user types as follows:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// # #![allow(dead_code)]</span>
<span class="doccomment">/// use rand::Rng;</span>
<span class="doccomment">/// use rand::distributions::{Distribution, Standard};</span>
<span class="doccomment">///</span>
<span class="doccomment">/// struct MyF32 {</span>
<span class="doccomment">///     x: f32,</span>
<span class="doccomment">/// }</span>
<span class="doccomment">///</span>
<span class="doccomment">/// impl Distribution&lt;MyF32&gt; for Standard {</span>
<span class="doccomment">///     fn sample&lt;R: Rng + ?Sized&gt;(&amp;self, rng: &amp;mut R) -&gt; MyF32 {</span>
<span class="doccomment">///         MyF32 { x: rng.gen() }</span>
<span class="doccomment">///     }</span>
<span class="doccomment">/// }</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ## Example usage</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use rand::prelude::*;</span>
<span class="doccomment">/// use rand::distributions::Standard;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// let val: f32 = StdRng::from_entropy().sample(Standard);</span>
<span class="doccomment">/// println!(&quot;f32 from [0, 1): {}&quot;, val);</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Floating point implementation</span>
<span class="doccomment">/// The floating point implementations for `Standard` generate a random value in</span>
<span class="doccomment">/// the half-open interval `[0, 1)`, i.e. including 0 but not 1.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// All values that can be generated are of the form `n * ε/2`. For `f32`</span>
<span class="doccomment">/// the 24 most significant random bits of a `u32` are used and for `f64` the</span>
<span class="doccomment">/// 53 most significant bits of a `u64` are used. The conversion uses the</span>
<span class="doccomment">/// multiplicative method: `(rng.gen::&lt;$uty&gt;() &gt;&gt; N) as $ty * (ε/2)`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// See also: [`Open01`] which samples from `(0, 1)`, [`OpenClosed01`] which</span>
<span class="doccomment">/// samples from `(0, 1]` and `Rng::gen_range(0, 1)` which also samples from</span>
<span class="doccomment">/// `[0, 1)`. Note that `Open01` and `gen_range` (which uses [`Uniform`]) use</span>
<span class="doccomment">/// transmute-based methods which yield 1 bit less precision but may perform</span>
<span class="doccomment">/// faster on some architectures (on modern Intel CPUs all methods have</span>
<span class="doccomment">/// approximately equal performance).</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [`Uniform`]: uniform::Uniform</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Standard</span>;


<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">test</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>))]</span>
<span class="kw">mod</span> <span class="ident">tests</span> {
    <span class="kw">use</span> <span class="kw">super</span>::{<span class="ident">Distribution</span>, <span class="ident">Uniform</span>};
    <span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">Rng</span>;

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_distributions_iter</span>() {
        <span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">distributions</span>::<span class="ident">Open01</span>;
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">rng</span> <span class="op">=</span> <span class="kw">crate</span>::<span class="ident">test</span>::<span class="ident">rng</span>(<span class="number">210</span>);
        <span class="kw">let</span> <span class="ident">distr</span> <span class="op">=</span> <span class="ident">Open01</span>;
        <span class="kw">let</span> <span class="ident">results</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">f32</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">distr</span>.<span class="ident">sample_iter</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">rng</span>).<span class="ident">take</span>(<span class="number">100</span>).<span class="ident">collect</span>();
        <span class="macro">println</span><span class="macro">!</span>(<span class="string">&quot;{:?}&quot;</span>, <span class="ident">results</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_make_an_iter</span>() {
        <span class="kw">fn</span> <span class="ident">ten_dice_rolls_other_than_five</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">R</span>: <span class="ident">Rng</span><span class="op">&gt;</span>(
            <span class="ident">rng</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> <span class="ident">R</span>,
        ) <span class="op">-</span><span class="op">&gt;</span> <span class="kw">impl</span> <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident">i32</span><span class="op">&gt;</span> <span class="op">+</span> <span class="lifetime">&#39;a</span> {
            <span class="ident">Uniform</span>::<span class="ident">new_inclusive</span>(<span class="number">1</span>, <span class="number">6</span>)
                .<span class="ident">sample_iter</span>(<span class="ident">rng</span>)
                .<span class="ident">filter</span>(<span class="op">|</span><span class="ident">x</span><span class="op">|</span> <span class="kw-2">*</span><span class="ident">x</span> <span class="op">!</span><span class="op">=</span> <span class="number">5</span>)
                .<span class="ident">take</span>(<span class="number">10</span>)
        }

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">rng</span> <span class="op">=</span> <span class="kw">crate</span>::<span class="ident">test</span>::<span class="ident">rng</span>(<span class="number">211</span>);
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">count</span> <span class="op">=</span> <span class="number">0</span>;
        <span class="kw">for</span> <span class="ident">val</span> <span class="kw">in</span> <span class="ident">ten_dice_rolls_other_than_five</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">rng</span>) {
            <span class="macro">assert</span><span class="macro">!</span>(<span class="ident">val</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">1</span> <span class="kw-2">&amp;</span><span class="op">&amp;</span> <span class="ident">val</span> <span class="op">&lt;</span><span class="op">=</span> <span class="number">6</span> <span class="kw-2">&amp;</span><span class="op">&amp;</span> <span class="ident">val</span> <span class="op">!</span><span class="op">=</span> <span class="number">5</span>);
            <span class="ident">count</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
        }
        <span class="macro">assert_eq</span><span class="macro">!</span>(<span class="ident">count</span>, <span class="number">10</span>);
    }
}
</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../../";window.currentCrate = "rand";</script><script src="../../../main.js"></script><script src="../../../source-script.js"></script><script src="../../../source-files.js"></script><script defer src="../../../search-index.js"></script></body></html>